#include <Arduino.h>
#include <SPI.h>
#include "ESP32SPISlave_t.h"



#define MOSI    40
#define MISO    39
#define SCK     38
#define CS      41

ESP32SPISlave slave;

#define BUFFER_SIZE 32
uint8_t spi_slave_tx_buf[BUFFER_SIZE];
uint8_t spi_slave_rx_buf[BUFFER_SIZE];


void setup() {
  Serial.begin(115200);
  slave.setDataMode(SPI_MODE0);
  slave.begin(HSPI, SCK, MISO, MOSI, CS);
  memset(spi_slave_tx_buf, 0, BUFFER_SIZE);
  memset(spi_slave_rx_buf, 0, BUFFER_SIZE);

}

void loop() {
    byte data;
    slave.wait(spi_slave_rx_buf, spi_slave_tx_buf, BUFFER_SIZE);
    while (slave.available()) {
      // show received data
      Serial.print("Command Received: ");
      data = spi_slave_rx_buf[0];
  
      Serial.println(data, HEX);
      Serial.print("TX buf"); Serial.print("|"); Serial.println("RX buf");
        for(int j=0;j<BUFFER_SIZE;j++)
        {
          Serial.print(spi_slave_tx_buf[j],HEX);Serial.print("|");
          Serial.println(spi_slave_rx_buf[j],HEX);
        }
      Serial.println("-------------------");
      slave.pop();
      if(data == 0x11){
        for(int j=0;j<BUFFER_SIZE;j++)
        {
          spi_slave_tx_buf[j]=j;
        }
        spi_slave_tx_buf[30] = 0x01;
      }
      if(data == 0x13){
          Serial.println("Send asked data");
       }
    }
}
